#pragma once
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include "TeaData.hpp"

class SmartDisplay
{
public:
    SmartDisplay(Adafruit_SSD1306 *display);

public:
    // lifecycle screens
    void printWaitForRFIDScreen();
    void printTeaConfigScreen(TeaData tea);
    void printTeaSteepingProgressScreen(TeaData tea, int remainingSeconds);
    void printRequestFeedbackScreen(TeaData tea);

public:
    // special screens
    void printAddNewTeaConfigScreen(TeaData tea, u_int *flicker);

    // animations
    void playTeaAnimation();
    void playRfidWaitAnimation(int frame);
    void playTeaAnimationPartOne(int xoffset, String line1, String line2, String line3, String line4);
    void playTeaAnimationPartTwo(int xoffset, String line1, String line2, String line3, String line4);
    void displayLoadingAnimationFrame(int xoffset);

    void wipe();

public:
    // helper methods
    void printMsg(const String &s);
    void printMsg(unsigned long l);
    void printMsgAt(int16_t x, int16_t y, const String &s);
    void resetDisplay();

private:
    Adafruit_SSD1306 *m_display;
    bool toggle = false;
};